/*!
FileReader.js - v0.99
A lightweight wrapper for common FileReader usage.
Copyright 2012 Brian Grinstead - MIT License.
See http://github.com/bgrins/filereader.js for documentation.
*/(function(a,b){function j(b){var c=a.URL||a.webkitURL,d=a.Blob,e=a.Worker;if(!c||!d||!e||!b)return null;var f=new d([b]),g=new e(c.createObjectURL(f));return g}function k(a,b){function d(a){var b=[],d=a.clipboardData||{},e=d.items||[];for(var f=0;f<e.length;f++){var g=e[f].getAsFile();if(g){var h=(new RegExp("/(.*)")).exec(g.type);if(!g.name&&h){var i=h[1];g.name="clipboard"+f+"."+i}b.push(g)}}b.length&&(p(a,b,c),a.preventDefault(),a.stopPropagation())}if(!i.enabled)return;var c=s(s({},i.opts),b);a.addEventListener("paste",d,!1)}function l(a,b){function d(b){p(b,a.files,c)}function e(a){a.stopPropagation(),a.preventDefault(),p(a,a.dataTransfer.files,c)}if(!i.enabled)return;var c=s(s({},i.opts),b);a.addEventListener("change",d,!1),a.addEventListener("drop",e,!1)}function m(a,c){function g(a){f=!1}function h(a){f=!0}function j(a){a.dataTransfer.files&&a.dataTransfer.files.length&&(a.stopPropagation(),a.preventDefault())}function k(a){return function(){f||a.apply(this,arguments)}}function l(b){b.stopPropagation(),b.preventDefault(),e&&v(a,e),p(b,b.dataTransfer.files,d)}function m(b){b.stopPropagation(),b.preventDefault(),e&&u(a,e)}function n(b){e&&v(a,e)}function o(b){b.stopPropagation(),b.preventDefault(),e&&u(a,e)}if(!i.enabled)return;var d=s(s({},i.opts),c),e=d.dragClass,f=!1;a.addEventListener("dragenter",k(m),!1),a.addEventListener("dragleave",k(n),!1),a.addEventListener("dragover",k(o),!1),a.addEventListener("drop",k(l),!1),b.body.addEventListener("dragstart",h,!0),b.body.addEventListener("dragend",g,!0),b.body.addEventListener("drop",j,!1)}function n(a,b){for(var c=0;c<a.length;c++){var d=a[c];d.extra={nameNoExtension:d.name.substring(0,d.name.lastIndexOf(".")),extension:d.name.substring(d.name.lastIndexOf(".")+1),fileID:c,uniqueID:y(),groupID:b,prettySize:w(d.size)}}}function o(a,b,c){for(var d in b)if(a.match(new RegExp(d)))return"readAs"+b[d];return"readAs"+c}function p(a,b,f){function m(){l.ended=new Date,f.on.groupend(l)}function p(){--k===0&&m()}var k=b.length,l={groupID:x(),files:b,started:new Date};i.output.push(l),n(b,l.groupID),f.on.groupstart(l);if(!b.length){m();return}var q=h&&d,r;q&&(r=j(e),r.onmessage=function(a){var b=a.data.file,c=a.data.result;b.extra||(b.extra=a.data.extra),b.extra.ended=new Date,f.on[c==="error"?"error":"load"]({target:{result:c}},b),p()}),Array.prototype.forEach.call(b,function(b){b.extra.started=new Date;if(f.accept&&!b.type.match(new RegExp(f.accept))){f.on.skip(b),p();return}if(f.on.beforestart(b)===!1){f.on.skip(b),p();return}var d=o(b.type,f.readAsMap,f.readAsDefault);if(r)r.postMessage({file:b,extra:b.extra,readAs:d});else{var e=new c;e.originalEvent=a,g.forEach(function(a){e["on"+a]=function(c){if(a=="load"||a=="error")b.extra.ended=new Date;f.on[a](c,b),a=="loadend"&&p()}}),e[d](b)}})}function q(){var a=j(f);a&&(a.onmessage=function(a){d=a.data},a.postMessage({}))}function r(){}function s(a,b){for(var c in b)b[c]&&b[c].constructor&&b[c].constructor===Object?(a[c]=a[c]||{},arguments.callee(a[c],b[c])):a[c]=b[c];return a}function t(a,b){return(new RegExp("(?:^|\\s+)"+b+"(?:\\s+|$)")).test(a.className)}function u(a,b){t(a,b)||(a.className=a.className?[a.className,b].join(" "):b)}function v(a,b){if(t(a,b)){var c=a.className;a.className=c.replace(new RegExp("(?:^|\\s+)"+b+"(?:\\s+|$)","g")," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}}function w(a){var b=["bytes","kb","MB","GB","TB","PB"],c=Math.floor(Math.log(a)/Math.log(1024));return(a/Math.pow(1024,Math.floor(c))).toFixed(2)+" "+b[c]}var c=a.FileReader,d=!1,e="self.addEventListener('message', function(e) { var data=e.data; try { var reader = new FileReaderSync; postMessage({ result: reader[data.readAs](data.file), extra: data.extra, file: data.file})} catch(e){ postMessage({ result:'error', extra:data.extra, file:data.file}); } }, false);",f="onmessage = function(e) { postMessage(!!FileReaderSync); };",g=["loadstart","progress","load","abort","error","loadend"],h=!1,i=a.FileReaderJS={enabled:!1,setupInput:l,setupDrop:m,setupClipboard:k,setSync:function(a){h=a,h&&!d&&q()},getSync:function(){return h&&d},output:[],opts:{dragClass:"drag",accept:!1,readAsDefault:"BinaryString",readAsMap:{},on:{loadstart:r,progress:r,load:r,abort:r,error:r,loadend:r,skip:r,groupstart:r,groupend:r,beforestart:r}}};typeof jQuery!="undefined"&&(jQuery.fn.fileReaderJS=function(a){return this.each(function(){jQuery(this).is("input")?l(this,a):m(this,a)})},jQuery.fn.fileClipboard=function(a){return this.each(function(){k(this,a)})});if(!c)return;var x=function(a){return function(){return a++}}(0),y=function(a){return function(){return a++}}(0);i.enabled=!0})(this,document);